# ---------------------------------------------------------------------------
# The contents of this file are subject to the JOnAS Public License Version 
# 1.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License on the JOnAS web site.
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied.
# See the License for the specific terms governing rights and limitations
# under the License.
#
# The Original Code is JOnAS application server code released July 1999.
#
# The Initial Developer of the Original Code is Bull S.A.
# The Original Code and portions created by Bull S.A. are
#    Copyright (C) 1999 Bull S.A. All Rights Reserved.
#
# Contributor(s): ______________________________________.
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# common Makefile


empty :=
space := $(empty) $(empty)

.SUFFIXES: .java .class _Stub.class .jj .sh .jpp .xml .jar .bat

ifeq ($(JDKDIR),)
ifeq ($(OSTYPE), cygwin32)
JDKDIR = /jdk1.2.2
else
JDKDIR = /usr/java1.2
endif
endif


OBJECTWEB_JDK = JAVA2


ifeq ($(JDKBIN),)
JDKBIN = $(JDKDIR)/bin
endif

ifeq ($(JAR),)
JAR = $(JDKBIN)/jar
endif
ifeq ($(JAVA),)
JAVA = $(JDKBIN)/java
endif
ifeq ($(JAVAC),)
JAVAC = $(JDKBIN)/javac
endif
ifeq ($(JAVADOC),)
JAVADOC = $(JDKBIN)/javadoc
endif
ifeq ($(JAVACC),)
JAVACC = javacc
endif
ifeq ($(OSTYPE), cygwin32)
	JAVACC_OUTPUT = -OUTPUT_DIRECTORY:.javacc_output
else
	JAVACC_OUTPUT = -OUTPUT_DIRECTORY=.javacc_output
endif
ifeq ($(RMIC),)
ifeq ($(OBJECTWEB_ORB),JEREMIE)
RMIC = $(JAVA) org.objectweb.jeremie.tools.jrmic.JRMICompiler -opt
else
RMIC = $(JDKBIN)/rmic
endif
endif

GENIC = $(JONAS_ROOT)/bin/unix/GenIC

JPP = $(JAVA) org.objectweb.build.JPP


ifndef OUTPUT_DIR
OUTPUT_DIR = $(ROOT)/output
endif
ifndef CLASS_DIR
CLASS_DIR = $(ROOT)/classes
endif
ifndef SRCTMP_DIR
SRCTMP_DIR = $(ROOT)/tmp
endif
ifndef JAVADOC_DIR
JAVADOC_DIR = $(OUTPUT_DIR)/jdoc
endif
ifndef LIB_DIR
LIB_DIR = $(OUTPUT_DIR)/lib
endif
ifndef BIN_DIR
BIN_DIR = $(OUTPUT_DIR)/bin
endif


PACKDIR = $(subst .,/,$(JAVAPACKAGE))
CLASSPACKDIR = $(CLASS_DIR)/$(PACKDIR)
COPYSRCDIR = $(SRCTMP_DIR)/$(PACKDIR)
PWDSRC = $(ROOT)/src/$(PACKDIR)


# jonas classes that must be included in the classpath
ifeq ($(JONAS_CLASSES),)
JONAS_CLASSES = $(JONAS_ROOT)/lib/$(OBJECTWEB_ORB)_jonas.jar
endif

ifeq ($(JPP_CLASSES),)
JPP_CLASSES = $(JONAS_ROOT)/lib/jpp.jar
endif

ifeq ($(JDBCEXT_CLASSES),)
JDBCEXT_CLASSES = /usr/local/lib/jdbc2_0-stdext.jar
endif

ifeq ($(JTA_CLASSES),)
	JTA_CLASSES = /usr/local/lib/jta-spec1_0_1.jar
endif

ifeq ($(JNDI_HOME),)
	JNDI_HOME = /usr/local
endif
ifeq ($(JNDI_CLASSES),)
	JNDI_CLASSES = $(JNDI_HOME)/lib/jndi.jar$(PS)$(JNDI_HOME)/lib/providerutil.jar$(PS)$(JNDI_HOME)/lib/rmiregistry.jar
endif
ifeq ($(EJB11_CLASSES),)
         EJB11_CLASSES = /usr/local/lib/ejb.jar
endif
ifeq ($(IDB_HOME),)
	IDB_HOME = /usr/local
endif
ifeq ($(IDB_CLASSES),)
	IDB_CLASSES = $(IDB_HOME)/lib/idb.jar$(PS)$(IDB_HOME)/lib/idbexmpl.jar
endif

ifeq ($(ORACLE_CLASSES),)
	ORACLE_CLASSES = /usr/local/lib/classes111.zip
endif

ifeq ($(JDBC_CLASSES),)
	JDBC_CLASSES = $(IDB_CLASSES)$(PS)$(ORACLE_CLASSES)
endif

CLASSPATH := $(JDBC_CLASSES)$(PS)$(JNDI_CLASSES)$(PS)$(EJB11_CLASSES)$(PS)$(JTA_CLASSES)$(PS)$(JDBCEXT_CLASSES)$(PS)$(JPP_CLASSES)$(PS)$(JONAS_CLASSES)$(PS)$(CLASS_DIR)$(PS)$(CLASSPATH)$(PS)$(XTRA_CLASSPATH)

JPPFLAGS += -D $(OBJECTWEB_JDK) -D $(OBJECTWEB_ORB)

ifneq ($(JCFLAGS),)
GENICFLAGS += -javacopts "$(JCFLAGS)"
endif
ifneq ($(RMICFLAGS),)
GENICFLAGS += -rmicopts "$(RMICFLAGS)"
endif

ifeq ($(EXPLICIT_PROP),true)
GENICFLAGS += -noimplpropag
endif

ifeq ($(OBJECTWEB_ORB),RMI)
RMICFLAGS = -keepgenerated -v1.1
endif


FILES_STUB = $(RMI_CLASSES:%=$(CLASSPACKDIR)/%_Stub.java)
FILES_RMI = $(RMI_CLASSES:%=$(CLASSPACKDIR)/%_Stub.class)
FILES_CLASS = $(CLASSES:%=$(CLASSPACKDIR)/%.class) $(RMI_CLASSES:%=$(CLASSPACKDIR)/%.class)
FILES_SRC = $(CLASSES:%=$(COPYSRCDIR)/%.java) $(RMI_CLASSES:%=$(COPYSRCDIR)/%.java)
FILES_SCRIPTS = $(SCRIPTS:%=$(CLASSPACKDIR)/%)
FILES_UNIXCOMMAND = $(UNIXCOMMANDS:%=$(BIN_DIR)/unix/%)
FILES_NTCOMMAND = $(NTCOMMANDS:%=$(BIN_DIR)/nt/%)
FILES_PARSER = $(JAVACCFILES:%=.javacc_output/%.output)
FILES_GENIC_XML = $(DDESCRS:%=$(CLASSPACKDIR)/%.genic_xml_output)
FILES_GENIC_JAR = $(EJBJARS:%=$(CLASSPACKDIR)/%.genic_jar_output)
FILES_EJBJARS = $(EJBJARS:%=$(CLASSPACKDIR)/%.jar)


$(CLASSPACKDIR)/%.class: %.java
	@echo $? >> .classes.list

$(CLASSPACKDIR)/%_Stub.class: %.java
	@echo $(JAVAPACKAGE).$(basename $?) >>.rmi.list

$(BIN_DIR)/unix/%: %.sh
	@[ -d $(BIN_DIR)/unix ] || mkdir -p $(BIN_DIR)/unix
	cp $< $@
	chmod a+x $@

$(BIN_DIR)/nt/%.bat: %.bat
	@[ -d $(BIN_DIR)/nt ] || mkdir -p $(BIN_DIR)/nt
	cp $< $@

$(CLASSPACKDIR)/%: %.sh
	@[ -d $(BIN_DIR) ] || mkdir -p $(BIN_DIR)
	cp $< $@
	chmod a+x $@

$(COPYSRCDIR)/%.java: %.java
	@[ -d $(COPYSRCDIR) ] || mkdir -p $(COPYSRCDIR)
	ln $< $@

%.java:	%.jpp
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JPP) $(JPPFLAGS) $?

./.javacc_output/%.output: %.jj
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JAVACC) $(JAVACC_OUTPUT) $(JCCFLAGS) $?
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(JAVAC) -d $(CLASS_DIR) $(JCFLAGS) `find .javacc_output -name '*.java' -print`
	>$@

$(CLASSPACKDIR)/%.genic_jar_output:	$(CLASSPACKDIR)/%.jar
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(GENIC) -d $(CLASS_DIR) $(GENICFLAGS) $<
	>$@

$(CLASSPACKDIR)/%.genic_xml_output:	%.xml
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	set -x ; \
	$(GENIC) -d $(CLASS_DIR) $(GENICFLAGS) $<
	>$@

$(CLASSPACKDIR)/%.jar: %.xml
	@[ -d $(CLASS_DIR)/META-INF ] || mkdir -p $(CLASS_DIR)/META-INF
	@cp $< $(CLASS_DIR)/META-INF/ejb-jar.xml
	@cp jonas-$< $(CLASS_DIR)/META-INF/jonas-ejb-jar.xml
	@cd $(CLASS_DIR) ; \
	set -x ; \
	$(JAR) cvf $(PACKDIR)/$*.jar META-INF/ejb-jar.xml META-INF/jonas-ejb-jar.xml $($*_CLASSES:%=$(PACKDIR)/%.class)
	@rm -f $(CLASS_DIR)/META-INF/ejb-jar.xml $(CLASS_DIR)/META-INF/jonas-ejb-jar.xml


all::
clean::
	rm -f $(CLASSPACKDIR)/core


ifneq ($(FILES_CLASS), $(space))
all::	compil

compil:	classes

classes: delete_classlist $(FILES_CLASS) compile_classlist

delete_classlist:
	@rm -f .classes.list

compile_classlist:
	@[ -d $(CLASS_DIR) ] || mkdir -p $(CLASS_DIR)
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	if [ -s .classes.list ] ; \
	then	set -x ; \
		$(JAVAC) -d $(CLASS_DIR) $(JCFLAGS) $(shell if [ -s .classes.list ] ; then cat .classes.list; fi ); \
	fi

clean::
	rm -f $(CLASSPACKDIR)/*.class
endif

ifneq ($(RMI_CLASSES),)
all::	rmi

rmi:	delete_rmilist $(FILES_RMI) compile_rmilist

delete_rmilist:
	@rm -f .rmi.list

compile_rmilist:
	@CLASSPATH="$(CLASSPATH)" ; PATH=$(PATH) ; export CLASSPATH PATH  ; \
	if [ -s .rmi.list ] ; \
	then	cd $(CLASS_DIR) ; set -x ; \
		$(RMIC) -d . $(RMICFLAGS) $(shell if [ -s .rmi.list ] ; then cat .rmi.list; fi ) ; \
	fi
endif

ifneq ($(SCRIPTS),)
all::	$(FILES_SCRIPTS)

clean::
	rm -f $(FILES_SCRIPTS)
endif

ifneq ($(UNIXCOMMANDS),)
all::	$(FILES_UNIXCOMMAND)

clean::
	rm -f $(FILES_UNIXCOMMAND)
endif

ifneq ($(NTCOMMANDS),)
all::	$(FILES_NTCOMMAND)

clean::
	rm -f $(FILES_NTCOMMAND)
endif

ifneq ($(JAVACCFILES),)
all::	$(FILES_PARSER)

clean::
	rm -rf ./.javacc_output
	rm -rf $(CLASSPACKDIR)/*.class
endif


ifneq ($(JARNAME),)
jar:
	[ -d $(LIB_DIR) ] || mkdir -p $(LIB_DIR)
	@(cd $(CLASS_DIR); \
	CLASSPATH="$(CLASSPATH)"; PATH=$(PATH) ; export CLASSPATH PATH ; \
	set -x ; \
	$(JAR) cv .) >$(LIB_DIR)/$(JARNAME).jar
endif

copysrc:: $(FILES_SRC)
ifneq ($(FILES_SRC), $(space))
	echo $(JAVAPACKAGE) >> $(JAVADOC_DIR)/package.list

tags::
	@etags -a -o $(PWD)/TAGS $(PWDSRC)/*.java $(PWDSRC)/*.jpp $(PWDSRC)/*.jj

endif

ifneq ($(EJBJARS),)
all::	$(FILES_EJBJARS) $(FILES_GENIC_JAR)

clean::
	rm -f $(CLASSPACKDIR)/*.genic_jar_output
	rm -f $(CLASSPACKDIR)/*.jar
	rm -f $(CLASSPACKDIR)/*.java $(CLASSPACKDIR)/*.java.save
endif

ifneq ($(DDESCRS),)
all::	$(FILES_GENIC_XML)

clean::
	rm -f $(CLASSPACKDIR)/*.genic_xml_output
	rm -f $(CLASSPACKDIR)/*.java $(CLASSPACKDIR)/*.java.save
endif

ifneq ($(SUBDIRS),)
tags::
	@rm -f TAGS

all clean run tags copysrc::
	@for p in $(SUBDIRS); do (cd ./$$p; $(MAKE) $@); done
endif

javadoc: jdinit copysrc
	@CLASSPATH="$(CLASSPATH)"; export CLASSPATH; set -x ; \
	$(JAVADOC) -d $(JAVADOC_DIR) -sourcepath $(SRCTMP_DIR) `cat $(JAVADOC_DIR)/package.list`

jdinit:
	@[ -d $(JAVADOC_DIR) ] || mkdir -p $(JAVADOC_DIR)
	rm -f $(JAVADOC_DIR)/package.list

clean::
	rm -rf $(JAVADOC_DIR) $(SRCTMP_DIR)

ifneq ($(LOCALFILES),)
all::
	[ -d $(OUTPUT_DIR) ] || mkdir -p $(OUTPUT_DIR)
	cp -Rf $(LOCALFILES) $(OUTPUT_DIR)
endif

clean_world: clean
	-rm -rf $(OUTPUT_DIR) $(CLASS_DIR)

env:
	@echo CLASSPATH=$(CLASSPATH)
	@echo PATH=$(PATH)
	@echo JAVAPACKAGE=$(JAVAPACKAGE)
	@echo FILES_SRC=$(FILES_SRC)
	@echo JDKVERSION=$(JDKVERSION)
	@echo JDKDIR=$(JDKDIR)
	@echo JDKBIN=$(JDKBIN)
	@echo OSTYPE=$(OSTYPE)
	@echo JTACLASSES=$(JTA_CLASSES)

#	@echo CLASSES=$(CLASSES)
#	@echo EJBJARS=$(EJBJARS)
#	@echo FILES_EJBJARS=$(FILES_EJBJARS)
#	@echo FILES_GENIC_JAR=$(FILES_GENIC_JAR)
#	@echo FILES_GENIC_XML=$(FILES_GENIC_XML)
