/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999,2000 Bull S.A. All Rights Reserved.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.container;

import org.objectweb.jonas.common.Service;
import org.objectweb.jonas.deployment.api.BeanDesc;

/**
 * EJB Service interface.
 */
public interface EJBService extends Service {

    /**
     * Add beans from a .xml or a .jar file
     */
    public void addBeans(String fileName);

    /**
     * Remove beans from the EJB Service
     */
    public void removeBeans(String fileName);

    /**
     * Remove all beans from the EJB Service
     */
    public void removeAllBeans();

    /**
     * List beans loaded in EJB Service
     */
    public String [] listBeans();
}

