/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999,2000 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.dbm;
  
import org.objectweb.jonas.common.Trace;

/**
 * Keeps pool as small as possible (after conn's has reached MaxAge)
 */
public class PoolKeeper extends Thread {

    private static final int trace = Trace.DB_8;

    protected Pool pool;

    public PoolKeeper(Pool pool) {
       super("PoolKeeper");
       setDaemon(true);
       this.pool = pool;
    }

    public void run() {

       Trace.outln(trace, "  PoolKeeper: started");

       while (true) {
	   try {
	       sleep(60 * 1000); // 60 sec
	       pool.check4MaxAge();
	   } catch (Exception ex) {
	       Trace.errln("  PoolKeeper: " + ex.toString());
	   }
       }
    }
}
