/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A. 
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): Lutris Technologies Inc http://www.lutris.com
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
*/

package org.objectweb.jonas.deployment.api;

/**
 * Class for descriptors of jdbc based container managed fields
 * @author Christophe Ney
 */
public class FieldJdbcDesc extends FieldDesc {
    

    protected String jdbcFieldName;

    /**
     * package protected constructor used by API
     */
    FieldJdbcDesc(String jdbcFieldName,boolean pkField){
        super(pkField);
        this.jdbcFieldName=jdbcFieldName;
    }
    
    
    /**
     * Get database field name in the table where bean is stored
     * @return Name of the field in the database
     */
    public String getJdbcFieldName(){
        return jdbcFieldName; 
    }
    
    /**
     * String representation of the object for test purpose
     * @return String representation of this object
     */
    public String toString() {
        StringBuffer ret = new StringBuffer();
        ret.append(super.toString());
        ret.append("\ngetJdbcFieldName()="+getJdbcFieldName());
        return ret.toString();
    }
    
}
