/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A. 
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): Lutris Technologies Inc http://www.lutris.com
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
*/

import java.lang.String;
import org.objectweb.jonas.deployment.api.*;
import org.objectweb.jonas.deployment.xml.*;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Hashtable;
import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.Writer;
import java.io.OutputStreamWriter;

/**
 * Class for testing org.objectweb.jonas.deployment.api
 * @author Christophe Ney
 */
public class TestDD {    
    
	public static void main(String[] args){
        if (args.length!=0) {
            System.out.println("usage java -cp [path] TestDD ");
            System.out.println(" where [path] includes the bean ejb-jar and all libraries needed by JonAS");
            return;
        }
        try {
            DeploymentDesc d = DeploymentDesc.getInstance(new SimpleClassLoader("C:\\lutris\\JONAS_TOP\\objectweb\\jonas\\src\\org\\objectweb\\jonas\\deployment\\tests\\eb_jar"));
            //DeploymentDesc d = DeploymentDesc.getInstance("C:\\lutris\\JONAS_TOP\\objectweb\\jonas\\src\\org\\objectweb\\jonas\\deployment\\tests\\eb_jar\\ejb-jar.xml","C:\\lutris\\JONAS_TOP\\objectweb\\jonas\\src\\org\\objectweb\\jonas\\deployment\\tests\\eb_jar\\jonas-ejb-jar.xml");
            System.out.println(d.toString());
        } catch (Exception e) {
            System.out.println("MESSAGE="+e.getMessage());
            System.out.println("STACKTRACE=");
            e.printStackTrace();
        }
    }

    static class SimpleClassLoader extends ClassLoader {

        String path;
        
        public SimpleClassLoader(String path) {
            if (!path.endsWith("/"))
                path+="/";
            this.path = path;
        }
        
        /**
         * This is the required version of loadClass which is called
         * both from loadClass above and from the internal function
         * FindClassFromClass.     */
        public synchronized Class loadClass(String className, boolean resolveIt)
            	throws ClassNotFoundException {
            byte data[] = new byte[640000];
            int l = 0;
            try {
                InputStream is = getResourceAsStream(className.replace('.','/')+".class");
                l = is.read(data);
                is.close();
            } catch(Exception e){
                try {
                    return super.findSystemClass(className);
                } catch (NoClassDefFoundError ex){
                    throw new ClassNotFoundException("Class not found: "+className);
                }
            }
            Class c= defineClass(className,data,0,l);
            if (resolveIt)
               resolveClass(c);
            return c;
        }
        
        public InputStream getResourceAsStream( String name ) {
            try {
                return new FileInputStream(path+name);
            } catch(FileNotFoundException e) {
                return null;
            }
        }
    }
}