/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id$
 */
import java.lang.String;
import org.objectweb.jonas.deployment.xml.*;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Hashtable;
import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import org.exolab.castor.util.Configuration;
               
/**
 * Class for testing org.objectweb.jonas.deployment.xml
 * @author Christophe Ney
 */
public class TestXML
{    
	public static void main(String[] args){
        if (args.length!=1) {
            System.out.println("usage java TestXML input.xml");
            System.out.println(" where input is an XML deployment descriptor for ejb-jar");
            return;
        }
        Configuration.getDefault();
	    try {
            FileReader reader = new FileReader(args[0]);
            JonasEjbJar ejbJar = JonasEjbJar.unmarshal(reader);
	    } catch ( Exception e ) {
            System.out.println("MESSAGE="+e.getMessage());
            System.out.println("STACKTRACE=");
            e.printStackTrace();
	    }
    }

    static class SimpleClassLoader extends ClassLoader {
       
        /**
         * This is the required version of loadClass which is called
         * both from loadClass above and from the internal function
         * FindClassFromClass.     */
        public synchronized Class loadClass(String className, boolean resolveIt)
            	throws ClassNotFoundException {
            return super.findSystemClass(className);
        }    
        
        public InputStream getResourceAsStream( String name ) {
            return SimpleClassLoader.class.getResourceAsStream(name);
        }
    }
}