/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.jtm;

import javax.transaction.Transaction;

/**
 * An object implements this interface to be aware of the end
 * of the transaction. Used only in case of the ConnectionManager.
 * Note that the standard Synchronization interface cannot be used because
 * first of all, tx is not supplied by afterCompletion, and then, because
 * beforeCompletion is not useful.
 */
public interface CompletedTransactionListener {
    /**
     * The end of this transaction occured.
     *
     * @param tx ths transaction object
     * @param status the status of the transaction completion
     */
    public void endTransaction(Transaction tx, int status);
}
