/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.jtm;

import java.util.Vector;
import org.objectweb.jonas.common.Trace;

/**
 * Log associated to a transaction
 */
class Log {

    /**
     * Constructor
     */
    public Log() {
	
	Trace.outln(logtrace, "Log constructor");
    }

    /**
     * add a Resource to the log
     */
    public void addResource(Resource res) {
	ResourceInfo ri = new ResourceInfo(res);
	resourceLogged.addElement(ri);
    }

    /**
     * flush Log with decision about the transaction
     */
    public void flushLog(int decide) {
	
	Trace.outln(logtrace, "flushLog: "+decide);
	decision = decide;

	// serialize log on disk
	// XXX
    }

    /**
     * forget log
     */
    public void forgetLog() {

	Trace.outln(logtrace, "forgetLog: ");

	// remove file on disk
	// XXX
    }
	
    /**
     * update log
     */
    public void updateLog() {

	Trace.outln(logtrace, "updateLog: ");

	// XXX
    }
	
    // Resources registered (Vector of ResourceInfo)
    Vector resourceLogged = new Vector();

    // Decision
    static final int DECISION_TO_COMMIT = 1;
    static final int DECISION_TO_ROLLBACK = 2;
    int decision;

    static int logtrace = Trace.DB_4;
}
