/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.ldap;

import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.Reference;
import javax.naming.spi.ObjectFactory;
import org.objectweb.jonas.common.Trace;

public class DataSourceLDAPImplFactory implements ObjectFactory {

    private static final int trace = Trace.DB_9;
    
    public Object getObjectInstance (Object refObj,
				     Name name,
				     Context nameCtx,
				     Hashtable env) throws Exception {
	Trace.outln(trace, "DataSourceLDAPImplFactory.getObjectInstance(Object refObj, Name name, Context nameCtx, Hashtable env)");

	Reference ref = (Reference) refObj;

	if (ref.getClassName().equals("org.objectweb.jonas.ldap.DataSourceLDAPImpl")) {
	    DataSourceLDAPImpl ds = new DataSourceLDAPImpl();
	    ds.setDataSourceName((String)ref.get("datasource.name").getContent());
	    ds.setUrl((String)ref.get("datasource.url").getContent());
	    ds.setUserName((String)ref.get("datasource.username").getContent());
	    ds.setPassword((String)ref.get("datasource.password").getContent());
	    return ds;
	} else 
	    return null;
    }
}
