/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */


package org.objectweb.jonas.naming;

import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * This interface allows different implementations of the
 * NamingManager, i.e. Enhydra Naming Service or JOnAS NamingManager.
 */
public interface ContainerNaming {

    /**
     * Create Context for application and components environment
     */
    public Context createComponentContext(String namespace) throws NamingException;

    /**
     * Return the Context associated with the current thread
     */
    public Context getComponentContext();

    /**
     * Associate this Context with the current thread.
     */
    public Context setComponentContext(Context ctx);

    /**
     * Get the initial context
     */
    public InitialContext getInitialContext();

    /**
     * return the environment associated to this initial context
     */
    public Hashtable getEnv();
}
